spec:
  inputs:
    stage:
      default: validate
    docker_hub_host:
      default: docker.io
---

include:
  - local: .gitlab-ci-other-versions.yml

gitleaks:
  stage: $[[ inputs.stage ]]
  needs: []
  image:
    name: $[[ inputs.docker_hub_host ]]/zricethezav/gitleaks:v${GL_COMMON_CI_TASKS_DEFAULT_GITLEAKS_VERSION}
    entrypoint: [""]

  # Being impacted by https://gitlab.com/gitlab-org/gitlab/-/issues/350100
  # This workaround has been applied:
  # https://gitlab.com/gitlab-org/gitlab/-/issues/350100#note_899547344
  variables:
    GIT_STRATEGY: clone # clone entire repo instead of reusing workspace
    GIT_DEPTH: 0 # avoid shallow clone

  script:
    - gitleaks detect
        --redact
        --report-format json
        --verbose
        --log-level debug
        --log-opts="origin/${CI_DEFAULT_BRANCH}.."
  after_script: |
    cat <<-EOD
    ----------------------------------------------------------
    Need help? Documentation on the gitleaks CI job can be found at:
    https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/gitleaks.md
    EOD
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" || $CI_PIPELINE_SOURCE == "parent_pipeline"'
      exists:
        - .gitleaks.toml
  # Automatically retry on any system blips
  retry:
    max: 2
    when:
      - runner_system_failure
